//strings for keyboard
const char character[] = "CDEFGAB";
const char note1[] ="C#";
const char note2[] ="Eb";
const char note3[] ="F#";
const char note4[] ="G#";
const char note5[] ="Bb";
const char note6[] = "C";
const char note7[] = "D";
const char note8[] = "E";
const char note9[] = "F";
const char note10[] = "G";
const char note11[] = "A";
const char note12[] = "B";

//Strings for printing on the LCD screen
const char ear[] = "EAR TRAINER";
const char mainMenu[]="MAIN MENU";
const char perfectPitch[]="PERFECT PITCH";
const char relativePitch[]="RELATIVE PITCH";
const char synthesizer[]="SYNTHESIZER";
const char cornell[] = "ECE4760 FINAL PROJECT";
const char author[] = "MGH44 + BC295";

//Holds the position of the notes for drawing keyboard.
const int dim[8] = {0, 19,  37, 56,  74,  93, 111, 130};
const int dim2[8] = {17, 35, 0, 72, 91, 109, 0, 0};
//holds the positino for relative pitch menu
const int dim3[13] = {46, 46, 58, 58, 70,70, 82,82, 94,94, 106, 106, 118};
//Strings for training
const char sReplay[] ="PLAY";
const char sExit[]="EXIT";
const char sLevel[]="LEVEL:";
const char sProgress[]="PROGRESS:";
const char sCorrect[]="CORRECT";
const char sIncorrect[] = "INCORRECT";
//strings for relative pitch
const char zeroStep[] = " 0: P1/-2";
const char oneStep[] = " 1: m2/+1";
const char twoStep[] = " 2: M2/-3";
const char threeStep[] = " 3: m3/+2";
const char fourStep[] = " 4: M3/-4";
const char fiveStep[] = " 5: P4/+3";
const char sixStep[] = " 6: +4/-5";
const char sevenStep[] = " 7: P5/-6";
const char eightStep[] = " 8: m6/+5";
const char nineStep[] = " 9: M6/-7";
const char tenStep[] = "10: m7/+6";
const char elevenStep[] = "11 :M7/-8";
const char twelveStep[] = "12 :P8/+7";

//frequencies of notes
#define C 274
#define CSHARP 291
#define D 308
#define DSHARP 326
#define E 346
#define F 366
#define FSHARP 388
#define G 411
#define GSHARP 435
#define A 461
#define ASHARP 489
#define B 518 

//LCD definition
#define CS_BIT 0x80
#define SCLK_BIT 0x40
#define SDATA_BIT 0x20
#define RST_BIT 0x00
#define lctCmd 0
#define lctData 1

//define u8 as unsinged char 
typedef unsigned char u8;

//State machine state names
#define Released 1
#define Debounce 2
#define Pushed 3
#define StillPushed 4
#define MaybeReleased 5
#define Done 6

//state machine update time
#define t1 30

// ramp constantsfor synthesizer
#define RAMPUPEND 250 
#define RAMPDOWNSTART 6250 
#define RAMPDOWNEND 6500 
// for training 
#define RAMPDOWNSTART2 15000
#define RAMPDOWNEND2 15250

//definition for key pressed
#define ENTER 1
#define LEFT 2
#define UP 3
#define DOWN 4
#define RIGHT 5

//MIDI variables
#define UART_BAUD  31250
#define status_byte 1
#define note_byte 0
#define vel_byte 2

//mode of the GUI
#define KEY 0
#define REPLAY 1
#define EXIT 2
//LCD EPSON CONTROLLER COMMAND LIST
#define DISON       0xaf
#define DISOFF      0xae
#define DISNOR      0xa6
#define DISINV      0xa7
#define COMSCN      0xbb
#define DISCTL      0xca
#define SLPIN       0x95
#define SLPOUT      0x94
#define PASET       0x75
#define CASET       0x15
#define DATCTL      0xbc
#define RGBSET8     0xce
#define RAMWR       0x5c
#define RAMRD       0x5d
#define PTLIN       0xa8
#define PTLOUT      0xa9
#define RMWIN       0xe0
#define RMWOUT      0xee
#define ASCSET      0xaa
#define SCSTART     0xab
#define OSCON       0xd1
#define OSCOFF      0xd2
#define PWRCTR      0x20
#define VOLCTR      0x81
#define VOLUP       0xd6
#define VOLDOWN     0xd7
#define TMPGRD      0x82
#define EPCTIN      0xcd
#define EPCOUT      0xcc
#define EPMWR       0xfc
#define EPMRD       0xfd
#define EPSRRD1     0x7c
#define EPSRRD2     0x7d
#define NOP         0x25

//from tutorial
#define BKLGHT_LCD_ON    1 
#define BKLGHT_LCD_OFF   2 
// backlight control   
#define BKLGHT_LCD_ON	1
#define BKLGHT_LCD_OFF	2 
// Booleans 
#define NOFILL	0 
#define FILL	1

// 12-bit color definitions 
#define WHITE  	0xFFF 
#define BLACK  	0x000 
#define RED 	0xF00 
#define LIME  	0x0F0 
#define BLUE 	0x00F 
#define CYAN 	0x0FF 
#define MAGENTA 0xF0F 
#define YELLOW 	0xFF0 
#define BROWN  	0xB22 
#define ORANGE 	0xFA0 
#define PINK 	0xF6A 
#define GREEN   0x080

//mask definitions
#define   BIT0    0x00000001 
#define   BIT1    0x00000002 
#define   BIT2    0x00000004 
#define   BIT3    0x00000008 
#define   BIT4    0x00000010 
#define   BIT5    0x00000020 
#define   BIT6    0x00000040 
#define   BIT7    0x00000080 
#define   BIT8    0x00000100 
#define   BIT9    0x00000200 
#define   BIT10   0x00000400 
#define   BIT11   0x00000800 
#define   BIT12   0x00001000 
#define   BIT13   0x00002000 
#define   BIT14   0x00004000 
#define   BIT15   0x00008000 
#define   BIT16   0x00010000 
#define   BIT17   0x00020000 
#define   BIT18   0x00040000 
#define   BIT19   0x00080000 
#define   BIT20   0x00100000 
#define   BIT21   0x00200000 
#define   BIT22   0x00400000 
#define   BIT23   0x00800000 
#define   BIT24   0x01000000 
#define   BIT25   0x02000000 
#define   BIT26   0x04000000 
#define   BIT27   0x08000000 
#define   BIT28   0x10000000 
#define   BIT29   0x20000000 
#define   BIT30   0x40000000 
#define   BIT31   0x80000000
//bitmap
const unsigned char FONT6x8[97][8] = 
{
0x06,0x08,0x08,0x00,0x00,0x00,0x00,0x00, // columns, rows, num_bytes_per_char
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // space 0x20
0x20,0x20,0x20,0x20,0x20,0x00,0x20,0x00, // !
0x50,0x50,0x50,0x00,0x00,0x00,0x00,0x00, // "
0x50,0x50,0xF8,0x50,0xF8,0x50,0x50,0x00, // #
0x20,0x78,0xA0,0x70,0x28,0xF0,0x20,0x00, // $
0xC0,0xC8,0x10,0x20,0x40,0x98,0x18,0x00, // %
0x40,0xA0,0xA0,0x40,0xA8,0x90,0x68,0x00, // &
0x30,0x30,0x20,0x40,0x00,0x00,0x00,0x00, // '
0x10,0x20,0x40,0x40,0x40,0x20,0x10,0x00, // (
0x40,0x20,0x10,0x10,0x10,0x20,0x40,0x00, // )
0x00,0x20,0xA8,0x70,0x70,0xA8,0x20,0x00, // *
0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00, // +
0x00,0x00,0x00,0x00,0x30,0x30,0x20,0x40, // ,
0x00,0x00,0x00,0xF8,0x00,0x00,0x00,0x00, // -
0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00, // .
0x00,0x08,0x10,0x20,0x40,0x80,0x00,0x00, // / (forward slash)
0x70,0x88,0x88,0xA8,0x88,0x88,0x70,0x00, // 0 0x30
0x20,0x60,0x20,0x20,0x20,0x20,0x70,0x00, // 1
0x70,0x88,0x08,0x70,0x80,0x80,0xF8,0x00, // 2
0xF8,0x08,0x10,0x30,0x08,0x88,0x70,0x00, // 3
0x10,0x30,0x50,0x90,0xF8,0x10,0x10,0x00, // 4
0xF8,0x80,0xF0,0x08,0x08,0x88,0x70,0x00, // 5
0x38,0x40,0x80,0xF0,0x88,0x88,0x70,0x00, // 6
0xF8,0x08,0x08,0x10,0x20,0x40,0x80,0x00, // 7
0x70,0x88,0x88,0x70,0x88,0x88,0x70,0x00, // 8
0x70,0x88,0x88,0x78,0x08,0x10,0xE0,0x00, // 9
0x00,0x00,0x20,0x00,0x20,0x00,0x00,0x00, // :
0x00,0x00,0x20,0x00,0x20,0x20,0x40,0x00, // ;
0x08,0x10,0x20,0x40,0x20,0x10,0x08,0x00, // <
0x00,0x00,0xF8,0x00,0xF8,0x00,0x00,0x00, // =
0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x00, // >
0x70,0x88,0x08,0x30,0x20,0x00,0x20,0x00, // ?
0x70,0x88,0xA8,0xB8,0xB0,0x80,0x78,0x00, // @ 0x40
0x20,0x50,0x88,0x88,0xF8,0x88,0x88,0x00, // A
0xF0,0x88,0x88,0xF0,0x88,0x88,0xF0,0x00, // B
0x70,0x88,0x80,0x80,0x80,0x88,0x70,0x00, // C
0xF0,0x88,0x88,0x88,0x88,0x88,0xF0,0x00, // D
0xF8,0x80,0x80,0xF0,0x80,0x80,0xF8,0x00, // E
0xF8,0x80,0x80,0xF0,0x80,0x80,0x80,0x00, // F
0x78,0x88,0x80,0x80,0x98,0x88,0x78,0x00, // G
0x88,0x88,0x88,0xF8,0x88,0x88,0x88,0x00, // H
0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00, // I
0x38,0x10,0x10,0x10,0x10,0x90,0x60,0x00, // J
0x88,0x90,0xA0,0xC0,0xA0,0x90,0x88,0x00, // K
0x80,0x80,0x80,0x80,0x80,0x80,0xF8,0x00, // L
0x88,0xD8,0xA8,0xA8,0xA8,0x88,0x88,0x00, // M
0x88,0x88,0xC8,0xA8,0x98,0x88,0x88,0x00, // N
0x70,0x88,0x88,0x88,0x88,0x88,0x70,0x00, // O
0xF0,0x88,0x88,0xF0,0x80,0x80,0x80,0x00, // P 0x50
0x70,0x88,0x88,0x88,0xA8,0x90,0x68,0x00, // Q
0xF0,0x88,0x88,0xF0,0xA0,0x90,0x88,0x00, // R
0x70,0x88,0x80,0x70,0x08,0x88,0x70,0x00, // S
0xF8,0xA8,0x20,0x20,0x20,0x20,0x20,0x00, // T
0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00, // U
0x88,0x88,0x88,0x88,0x88,0x50,0x20,0x00, // V
0x88,0x88,0x88,0xA8,0xA8,0xA8,0x50,0x00, // W
0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x00, // X
0x88,0x88,0x50,0x20,0x20,0x20,0x20,0x00, // Y
0xF8,0x08,0x10,0x70,0x40,0x80,0xF8,0x00, // Z
0x78,0x40,0x40,0x40,0x40,0x40,0x78,0x00, // [
0x00,0x80,0x40,0x20,0x10,0x08,0x00,0x00, // \ (back slash)
0x78,0x08,0x08,0x08,0x08,0x08,0x78,0x00, // ]
0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00, // ^
0x00,0x00,0x00,0x00,0x00,0x00,0xF8,0x00, // _
0x60,0x60,0x20,0x10,0x00,0x00,0x00,0x00, // ` 0x60
0x00,0x00,0x60,0x10,0x70,0x90,0x78,0x00, // a
0x80,0x80,0xB0,0xC8,0x88,0xC8,0xB0,0x00, // b
0x00,0x00,0x70,0x88,0x80,0x88,0x70,0x00, // c
0x08,0x08,0x68,0x98,0x88,0x98,0x68,0x00, // d
0x00,0x00,0x70,0x88,0xF8,0x80,0x70,0x00, // e
0x10,0x28,0x20,0x70,0x20,0x20,0x20,0x00, // f
0x00,0x00,0x70,0x98,0x98,0x68,0x08,0x70, // g
0x80,0x80,0xB0,0xC8,0x88,0x88,0x88,0x00, // h
0x20,0x00,0x60,0x20,0x20,0x20,0x70,0x00, // i
0x10,0x00,0x10,0x10,0x10,0x90,0x60,0x00, // j
0x80,0x80,0x90,0xA0,0xC0,0xA0,0x90,0x00, // k
0x60,0x20,0x20,0x20,0x20,0x20,0x70,0x00, // l
0x00,0x00,0xD0,0xA8,0xA8,0xA8,0xA8,0x00, // m
0x00,0x00,0xB0,0xC8,0x88,0x88,0x88,0x00, // n
0x00,0x00,0x70,0x88,0x88,0x88,0x70,0x00, // o
0x00,0x00,0xB0,0xC8,0xC8,0xB0,0x80,0x80, // p 0x70
0x00,0x00,0x68,0x98,0x98,0x68,0x08,0x08, // q
0x00,0x00,0xB0,0xC8,0x80,0x80,0x80,0x00, // r
0x00,0x00,0x78,0x80,0x70,0x08,0xF0,0x00, // s
0x20,0x20,0xF8,0x20,0x20,0x28,0x10,0x00, // t
0x00,0x00,0x88,0x88,0x88,0x98,0x68,0x00, // u
0x00,0x00,0x88,0x88,0x88,0x50,0x20,0x00, // v
0x00,0x00,0x88,0x88,0xA8,0xA8,0x50,0x00, // w
0x00,0x00,0x88,0x50,0x20,0x50,0x88,0x00, // x
0x00,0x00,0x88,0x88,0x78,0x08,0x88,0x70, // y
0x00,0x00,0xF8,0x10,0x20,0x40,0xF8,0x00, // z
0x10,0x20,0x20,0x40,0x20,0x20,0x10,0x00, // {
0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00, // |
0x40,0x20,0x20,0x10,0x20,0x20,0x40,0x00, // }
0x40,0xA8,0x10,0x00,0x00,0x00,0x00,0x00, // ~
0x70,0xD8,0xD8,0x70,0x00,0x00,0x00,0x00}; // DEL



